unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, QuickRpt, StdCtrls, Buttons, ExtCtrls, QRCtrls, DB,
  ADODB, EditN, dateTimePickerN, ComboboxN;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    PanelInput: TPanel;
    QuickRep1: TQuickRep;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    StatusBar1: TStatusBar;
    function changefileset(ss:string):string;  //䴩_Xly
    function StringToComponent(Value: string;parent:Tcomponent): TComponent;
    Function Getmem(var htm:string):boolean;
    Function GetBodyini:boolean;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure QuickRep1Preview(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Fname,Fhead,Fsize:Tstringlist;
  FromF: file;

implementation

uses preview,zlib;

{$R *.dfm}
function TForm1.changefileset(ss:string):string;  //䴩_Xly
const keywords: array[1..6] of string = ('SELECT ', 'FROM ', 'WHERE ', 'GROUP ', 'ORDER ', 'HAVING');
var s1,s2,s3,s4:string;
    kc:array[1..6] of integer;
    i,j,k:integer;
    st,st2:Tstringlist;
    Filerepl:array[1..26,1..2] of string;  //̦h26ɦW
    Filerepl_co:integer;
begin
   if not (trim(ss)='') then
   begin
      ST:=Tstringlist.Create;
      st2:=Tstringlist.Create;
      for i:=0 to st2.Count-1 do
      begin
         s1:=uppercase(st2[i]);
         s2:=st2[i];
         j:=1;
         s4:='';
         while (j<=6) do
         begin
            k:=pos(keywords[j],s1);
            if k>0 then
            begin
               if not (k=1) then
               begin
                  s3:=s4+copy(s2,1,k-1);
                  st.Add(s3);
               end;
               s4:=keywords[j];
               s1:=copy(s1,k+length(keywords[j]),length(s1)-k-length(keywords[j])+1);
               s2:=copy(s2,k+length(keywords[j]),length(s2)-k-length(keywords[j])+1);
               j:=0;
            end;
            j:=j+1;
         end;
         st.Add(s4+s2);
      end;
      result:=st.Text;
      st.Free;
      st2.Free;
   end;
end;


function TForm1.StringToComponent(Value: string;parent:Tcomponent): TComponent;
var
  StrStream:TStringStream;
  BinStream: TMemoryStream;
begin
  StrStream := TStringStream.Create(Value);
  try
    BinStream := TMemoryStream.Create;
    try
      ObjectTextToBinary(StrStream, BinStream);
      BinStream.Seek(0, soFromBeginning);
      Result := BinStream.ReadComponent(parent);

    finally
      BinStream.Free;
    end;
  finally
    StrStream.Free;
  end;
end;


Function TForm1.Getmem(var htm:string):boolean;
var  Fmem,cp:Tmemorystream;
     cp1:TDeCompressionStream;
     i,NumRead,writetot:integer;
     Buf: array[1..2048] of Char;
     s,s1:string;
     f:textfile;
begin
   i:=fname.IndexOf(htm);
//   showmessage(htm+','+inttostr(i));
   htm:='';
   if not (i=-1) then
   begin
      cp:=TMemoryStream.Create;
      try
         seek(fromf,strtoint(Fhead.strings[i]));//head
         writetot:=0;
         repeat
            BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
            if writetot+NumRead>strtoint(Fsize.strings[i]) then
               NumRead:=(strtoint(Fsize.strings[i])-writetot);
            writetot:=writetot+numread;
            cp.write(buf,numread);
         until (NumRead = 0) or (writetot>=strtoint(Fsize.strings[i]));
         cp1:=TDeCompressionStream.Create(cp);
         cp1.Position:=0;
         htm:='';
         repeat
            numRead:=cp1.Read(buf,sizeof(buf));
            if numread<sizeof(buf) then
            begin
               s:=buf;
               htm:=htm+copy(s,1,numread);
            end else
              htm:=htm+buf;
         until (numRead=0);
//         if pos('/',fname.Strings[i])>0 then
//            s1:=copy(fname.Strings[i],pos('/',fname.Strings[i])+1,length(fname.Strings[i])-pos('/',fname.Strings[i]))
//         else
//            s1:=fname.Strings[i];
//         assignfile(f,s1);
//         rewrite(f);
//         write(f,htm);
//         closefile(f);
         freeandnil(cp1);
         result:=true;
      except
         result:=false;
      end;
      freeandnil(cp);
   end else
      result:=false;
end;


Function TForm1.GetBodyini:boolean;
var  NumRead, NumWritten: Integer;
  Buf: array[1..2048] of Char;
  filerec:record
     filename:string[80];
     filesize:integer;
  end;
  writetot:integer;
  ok:boolean;
  Fmem:Tmemorystream;
  s:string;
begin
   try
      Fmem:=tmemorystream.Create;
      ok:=true;
      seek(fromf,filesize(fromf)-sizeof(filerec));   //ɮצW
      BlockRead(FromF,filerec,sizeof(filerec));
   //  caption:=filerec.filename+' '+inttostr(filerec.filesize);
      seek(fromf,filesize(fromf)-sizeof(filerec)-filerec.filesize);
      writetot:=0;
      repeat
         BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
         if writetot+NumRead>filerec.filesize then
            NumRead:=(filerec.filesize-writetot);
         Fmem.WriteBuffer(buf,NumRead);
      until (NumRead = 0);
      fmem.Position:=0;
      Fsize.LoadFromStream(fmem);
      result:=ok;
   finally
      fmem.Free;
   end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var s,s1:string;
    i,j:integer;
begin
   RegisterClasses([TQRsubdetail,TQRStringsBand,TQRBand,TQRGroup,TQRLabel,
         TQRDBText,TQRExpr,TQRSysData,TQRMemo,TQRRichText,
         TQRDBrichtext,TQRSHAPE,TQRIMAGE,TQRDBImage,TADOConnection,TADOQuery,
         TLabel,TEDitN,TComboboxN,TDateTimePickerN]);
   for i:=0 to PageControl1.PageCount-1 do
      PageControl1.Pages[i].TabVisible:=false;
   PageControl1.ActivePageIndex:=0;
   assignfile(fromf,application.ExeName);
   FileMode := 0;  {Set file access to read only }
   reset(fromf,1);
   Fname:=tstringlist.Create;
   FHead:=tstringlist.Create;
   Fsize:=tstringlist.Create;
   if GetBodyini then
   begin
      for i:=0 to Fsize.Count-1 do
      begin
         s:=Fsize.Strings[i];
         j:=pos('|',s);
         Fname.Add(copy(s,1,j-1));
         s:=copy(s,j+1,length(s)-j);
         j:=pos('|',s);
         FHead.Add(copy(s,1,j-1));
         Fsize.Strings[i]:=copy(s,j+1,length(s)-j);
      end;
      s:='PanelInput';
      if Getmem(s) then
         StringToComponent(s,PanelInput);
      s:='Quickrep1';
      if Getmem(s) then
         StringToComponent(s,Quickrep1);
   end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var i,j:integer;
    s,s1,svalue:string;
    ADOQ:TADOQuery;
    fi_wh:boolean;
begin
   for i:=0 to Quickrep1.ComponentCount-1 do
   begin
      if (Quickrep1.Components[i] is TADOQuery) then
      begin
         (Quickrep1.Components[i] as TADOQuery).Active:=false;

//         (Quickrep1.Components[i] as TADOQuery).SQL.Text:=changefileset((Quickrep1.Components[i] as TADOQuery).SQL.Text);
//         showmessage((Quickrep1.Components[i] as TADOQuery).sql.text);
      end;
   end;
   StatusBar1.SimpleText:='1';
   application.ProcessMessages;
   for i:=0 to PanelInput.ComponentCount-1 do
   begin
      if (PanelInput.Components[i] is TEditN) or (PanelInput.Components[i] is TComboboxN) or
         (PanelInput.Components[i] is TDateTimePickerN) then
      begin
         svalue:='';
         if (PanelInput.Components[i] is TDateTimePickerN) then
            svalue:=formatfloat('yyyy/mm/dd',(PanelInput.Components[i] as TDateTimePickerN).date)
         else
            svalue:=TEditN(PanelInput.Components[i]).text;
         if not (svalue='') then
         begin
            s1:='and '+(PanelInput.Components[i] as TEditN).FieldName;
            case ord((PanelInput.Components[i] as TEditN).Op) of  //r
               ord(OnEqual):s1:=s1+' = '+Quotedstr(svalue);
               ord(ONLarge):s1:=s1+' > '+Quotedstr(svalue);
               ord(ONLargeEqual):s1:=s1+' >= '+Quotedstr(svalue);
               ord(ONSmall):s1:=s1+' < '+Quotedstr(svalue);
               ord(ONSmallEqual):s1:=s1+' <= '+Quotedstr(svalue);
               ord(ONLikeFirst):s1:=s1+' like '+Quotedstr(svalue+'%');
               ord(ONLikeMid):s1:=s1+' like '+Quotedstr('%'+svalue+'%');
               ord(ONLikeEnd):s1:=s1+' like '+Quotedstr('%'+svalue);
            end;
            ADOQ:=TADOquery(Quickrep1.FindComponent((PanelInput.Components[i] as TEditN).DataSetname));
            if ADOQ=nil then
            else
            begin
               s:=ADOQ.SQL.Text;
               fi_wh:=pos('WHERE ',uppercase(s))>0;
               j:=pos('GROUP BY',s);
               if j=0 then
               begin
                  j:=pos('ORDER BY',s);
                  if j=0 then
                     j:=length(s);
               end;
               if not fi_wh then
               begin
                  ADOQ.SQL.Text:=copy(s,1,j-1)+'WHERE 1>0 '+s1+' '+copy(s,j,length(s)-j+1);
               end else
               begin
                  ADOQ.SQL.Text:=copy(s,1,j-1)+s1+' '+copy(s,j,length(s)-j+1);
               end;
            end;
         end;
      end;
   end;
   StatusBar1.SimpleText:='2';
   application.ProcessMessages;
   for i:=0 to Quickrep1.ComponentCount-1 do
   begin
      if (Quickrep1.Components[i] is TADOQuery) then
      begin
         showmessage((Quickrep1.Components[i] as TADOQuery).sql.text);
         (Quickrep1.Components[i] as TADOQuery).Active:=True;
      end;
   end;
   QuickRep1.Prepare;
   QuickRep1.PreviewModal;
end;

procedure TForm1.QuickRep1Preview(Sender: TObject);
begin
   preview.crpreview(self,sender);
end;

end.
