unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, DB, ADODB, StdCtrls, Mask, DBCtrls, ExtCtrls, Grids,
  DBGrids, Buttons, QuickRpt, ToolWin, Handles, QRCtrls,typinfo, EditN,
  ComboBoxN, dateTimePickerN;

type
  TOperationN = (ONnone,OnEqual,ONLarge,ONLargeEqual,ONSmall,ONSmallEqual,ONLikeFirst,ONLikeMid,ONLikeEnd);

type
  TFormWRC = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ADOConnectionSA: TADOConnection;
    ADOProj: TADOQuery;
    ADOProjproj_no: TWideStringField;
    ADOProjproj_name: TWideStringField;
    ADOProjproj_alias: TWideStringField;
    DBGrid1: TDBGrid;
    DataSourceProj: TDataSource;
    Panel1: TPanel;
    Panel2: TPanel;
    DBNavigator1: TDBNavigator;
    Panel3: TPanel;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    ADOConnection2: TADOConnection;
    ADOproj_dataset: TADOQuery;
    ADOproj_datasetproj_no: TWideStringField;
    ADOproj_datasetdataset_class: TIntegerField;
    DBGrid2: TDBGrid;
    ADOproj_datasetdataset_name: TWideStringField;
    Panel4: TPanel;
    Panel5: TPanel;
    DBNavigator2: TDBNavigator;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    ADOproj_datasetdataset_sql: TMemoField;
    Label6: TLabel;
    DBMemo1: TDBMemo;
    TabSheet3: TTabSheet;
    Panel6: TPanel;
    DataSourceproj_dataset: TDataSource;
    StretchHandle1: TStretchHandle;
    Panel9: TPanel;
    Splitter1: TSplitter;
    ToolBar2: TToolBar;
    SpeedButtonLoad: TSpeedButton;
    SpeedButtonSave: TSpeedButton;
    ADOProjproj_report: TMemoField;
    Label7: TLabel;
    DBMemo2: TDBMemo;
    SpeedButtonClear: TSpeedButton;
    GroupBox1: TGroupBox;
    TreeView1: TTreeView;
    Splitter2: TSplitter;
    GroupBox2: TGroupBox;
    Panel10: TPanel;
    ComboBox1: TComboBox;
    sgProp: TStringGrid;
    ListSet: TListBox;
    EditNum: TEdit;
    ComboEnum: TComboBox;
    PageControl2: TPageControl;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Panel7: TPanel;
    ScrollBox1: TScrollBox;
    QuickRep1: TQuickRep;
    Panel8: TPanel;
    ToolBar1: TToolBar;
    SpeedButton0: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    PanelInput: TPanel;
    Panel11: TPanel;
    ToolBar3: TToolBar;
    TabSheet6: TTabSheet;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    SpeedButton19: TSpeedButton;
    ADOProjproj_input: TMemoField;
    Label8: TLabel;
    DBMemo3: TDBMemo;
    Button1: TButton;
    Function Makeexefile(var tof:file;var ini:textfile;sn,sm:string):boolean;
    Function Makeexe(ExeFileName,HeadExeFile:string):boolean;
    procedure AddToCombo (const S: String);
    procedure ListEnum (pti: PTypeInfo; sList: TStrings; ShowIndex: Boolean);
    function GetOwnerForm (Comp: TComponent): TComponent;
    function IsBitOn (Value: Integer; Bit: Byte): Boolean;
    function SetToString (Value: Cardinal;
         pti: PTypeInfo): string;
    function GetPropValAsString (Obj: TObject;
         PropInfo: PPropInfo): string;
    procedure OnobjDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ONobjDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ObjectMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure onquickrepmousedown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label3Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure ADOproj_datasetBeforePost(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    function ComponentToString(Component: TComponent): string;
    function StringToComponent(Value: string;parent:Tcomponent): TComponent;
    procedure SpeedButtonSaveClick(Sender: TObject);
    procedure SpeedButtonLoadClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButtonClearClick(Sender: TObject);
    procedure StretchHandle1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox1CloseUp(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure sgPropSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ComboEnumExit(Sender: TObject);
    procedure SpeedButton19Click(Sender: TObject);
    procedure ComboEnumChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    idx,idx2:integer;
    combo:TComboboX;
    currrow:integer;
    CurrComp: TComponent;
    CurrProp: PPropInfo;
    datasetname:string;
    numtot:integer;
  end;

var
  FormWRC: TFormWRC;
  vnull:Olevariant;

implementation

uses ADOConEd,zlib;

{$R *.dfm}

Function TFormWRC.Makeexefile(var tof:file;var ini:textfile;sn,sm:string):boolean;
var  NumRead, NumWritten,Numtotf: Integer;
     Buf: array[1..2048] of Char;
     s1:string;
     cp:Tmemorystream;
     cp1:TCompressionStream;
begin
  cp:=tmemorystream.Create;
  try
     cp.Clear;
     try  //Y
        cp1:=TCompressionStream.Create(clDefault,cp);
        cp1.Write(sm[1],length(sm));
     finally
        freeandnil(cp1);
     end;
     cp.Position:=0;
     numtotf:=0;
     repeat  //[Jɧ
        NumRead:=cp.Read(buf,sizeof(buf));
        BlockWrite(ToF, Buf, NumRead, NumWritten);
        numtotf:=numtotf+NumWritten;
     until (NumRead = 0) or (NumWritten <> NumRead);
     if NumWritten <> NumRead then
        result:=false;
     s1:=sn+'|'+inttostr(numtot)+'|'+inttostr(numtotf);
     writeln(ini,s1);
     numtot:=numtot+numtotf;
  except
     freeandnil(cp);
  end;
end;

Function TFormWRC.Makeexe(ExeFileName,HeadExeFile:string):boolean;
var  FromF, ToF: file;
     ini:textfile;
     NumRead, NumWritten,Numtotf: Integer;
     Buf: array[1..2048] of Char;
     filerec:record
        filename:string[80];
        filesize:integer;
     end;
     ok:boolean;
     s,s1,sm,st:string;
begin
  result:=false;
  s:='';
  AssignFile(ToF, ExeFileName);	{ Open output file }
  try
     Rewrite(ToF, 1);	{ Record size = 1 }
        // Save HeadExeFile
     assignfile(fromf,HeadExeFile);
     FileMode := 0;  {Set file access to read only }
     reset(fromf,1);
     numtot:=0;
     repeat
        BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
        BlockWrite(ToF, Buf, NumRead, NumWritten);
        numtot:=numtot+NumWritten;
     until (NumRead = 0) or (NumWritten <> NumRead);
     CloseFile(FromF);
     if NumWritten <> NumRead then
        ok:=false;
     s:=Extractfiledir(ExeFileName)+'\'+ExtractFileName(ExeFileName);
     s:=ChangeFileExt(s, '.ini');
//bodyβini
     assignfile(ini,s);
     rewrite(ini);                //gJbody
     Makeexefile(tof,ini,'PanelInput',ComponentToString(PanelInput));
     Makeexefile(tof,ini,'Quickrep1',ComponentToString(Quickrep1));
     CloseFile(ini);
//
     assignfile(fromf,s);  //NinigJ
     FileMode := 0;  {Set file access to read only }
     reset(fromf,1);
     FileRec.filename:=extractfilename(s);
     FileRec.filesize:=0;
     repeat
        BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
        BlockWrite(ToF, Buf, NumRead, NumWritten);
        FileRec.filesize:=FileRec.filesize+NumWritten;
     until (NumRead = 0) or (NumWritten <> NumRead);
     CloseFile(fromf);
     if NumWritten <> NumRead then
        ok:=false;
     // Save File Record
     BlockWrite(ToF,filerec,sizeof(filerec));
     DeleteFile(s);
  except
     result:=false;
  end;
  CloseFile(ToF);
  if messagedlg(ExeFileName+'{ͧ...O_}ҵ{',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
     winexec(pchar(exefilename),SW_SHOW);
  result:=true;
end;

procedure TFormWRC.ListEnum (pti: PTypeInfo; sList: TStrings; ShowIndex: Boolean);
var I: Integer;
begin
  with GetTypeData(pti)^ do
    for I := MinValue to MaxValue do
      if ShowIndex then
        sList.Add ('  ' + IntToStr (I) + '. ' +
         GetEnumName (pti, I))
      else
        sList.Add (GetEnumName (pti, I));
end;

function TFormWRC.GetOwnerForm (Comp: TComponent): TComponent;
begin
  while not (Comp is TForm) and
      not (Comp is TDataModule) do
    Comp := Comp.Owner;
  Result := Comp;
end;

function TFormWRC.IsBitOn (Value: Integer; Bit: Byte): Boolean;
begin
  Result := (Value and (1 shl Bit)) <> 0;
end;

function TFormWRC.SetToString (Value: Cardinal;
  pti: PTypeInfo): string;
var
  Res: String;  // result
  BaseType: PTypeInfo;
  I: Integer;
  Found: Boolean;
begin
  Found := False;
  // open the expression
  Res := '[';
  // get the type of the enumeration
  // the set is based onto
  BaseType := GetTypeData(pti).CompType^;
  // for each possible value
  for I := GetTypeData (BaseType).MinValue
      to GetTypeData (BaseType).MaxValue do
    // if the bit I (computed as 1 shl I) is set,
    // then the corresponding element is in the set
    // (the and is a bitwise and, not a boolean operation)
    if IsBitOn (Value, I) then
    begin
      // add the name of the element
      Res := Res + GetEnumName (BaseType, I) + ', ';
      Found := True;
    end;
  if Found then
    // remove the final comma and space (2 chars)
    Res := Copy (Res, 1, Length (Res) - 2);
  // close the expression
  Result := Res + ']';
end;

function TFormWRC.GetPropValAsString (Obj: TObject;
  PropInfo: PPropInfo): string;
var
  Pt: Pointer;
  Word: Cardinal;
begin
  case PropInfo.PropType^.Kind of

    tkUnknown:
      Result := 'Unknown type';

    tkChar:
    begin
      Word := GetOrdProp (Obj, PropInfo);
      if Word > 32 then
        Result := Char (Word)
      else
        Result := '#' + IntToStr (Word);
    end;

    tkWChar:
    begin
      Word := GetOrdProp (Obj, PropInfo);
      if Word > 32 then
        Result := WideChar (Word)
      else
        Result := '#' + IntToStr (Word);
    end;


    tkInteger:
      if PropInfo.PropType^.Name = 'TColor' then
        Result := ColorToString (GetOrdProp (Obj, PropInfo))
      else if PropInfo.PropType^.Name = 'TCursor' then
        Result := CursorToString (GetOrdProp (Obj, PropInfo))
      else
        Result := Format ('%d', [GetOrdProp (Obj, PropInfo)]);

    tkEnumeration:
      Result := GetEnumName (PropInfo.PropType^,
        GetOrdProp (Obj, PropInfo));

    tkFloat:
      Result := FloatToStr (GetFloatProp (Obj, PropInfo));

    tkString, tkLString:
      Result := GetStrProp (Obj, PropInfo);

    tkSet:
      Result := SetToString (GetOrdProp (Obj, PropInfo),
        PropInfo.PropType^);

    tkClass:
    begin
      Pt := Pointer (GetOrdProp (Obj, PropInfo));
      if Pt = nil then
        Result := '(None)'
      else
        Result := Format ('(Object %p)', [Pt]);
    end;

    tkMethod:
    begin
      Pt := GetMethodProp (Obj, PropInfo).Code;
      if Pt <> nil then
        Result := GetOwnerForm (Obj as TComponent).
          MethodName (Pt)
      else
        Result := '';
    end;

    tkVariant:
      Result := GetVariantProp (Obj, PropInfo);

    tkArray, tkRecord, tkInterface:
      Result := 'Unsupported type';

    else
      Result := 'Undefined type';
  end;
end;

procedure TFormWRC.ObjectMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var PropInfo: PPropInfo;
    PropList, SubPropList: TPropList;
    NumberOfProps, NumberOfSubProps, // total number of properties
    nProp, nSubProp, // property loop counter
    nRowProp, nRowEvt: Integer; // items actually added
    SubObj: TPersistent;
begin
  if (GetKeyState(VK_SHIFT) >= 0) then
  begin
      StretchHandle1.Detach;
      StretchHandle1.Locked := False;
  end;
  if (idx=0) or not ((Sender is TQRBand) or (Sender is TQRSubdetail) or
     (Sender is TQRGroup) or (Sender is TQRSTringsBand) ) then
  begin
     Combobox1.ItemIndex:=Combobox1.Items.IndexOfObject(Tcomponent(sender));
     CurrComp := ComboBox1.Items.Objects [
          ComboBox1.ItemIndex] as TComponent;
     StretchHandle1.Attach(TButton(sender));
     sgProp.Cells [1, 0] := '';
   // get the number of properties
     NumberOfProps := GetTypeData(Sender.ClassInfo).PropCount;
  // exaggerate in size...
     sgProp.RowCount := NumberOfProps;
  // get the list of properties and sort it
     GetPropInfos (Sender.ClassInfo, @PropList);
     SortPropList(@PropList, NumberOfProps);
// show the name of each property
// adding it to the proper page
     nRowProp := 0;
     nRowEvt := 0;
     for nProp := 0 to NumberOfProps - 1 do
     begin
// if it is a real property
        if PropList[nProp].Name='DataSet' then
        begin
           sgProp.Cells [0, nRowProp] := PropList[nProp].Name;
           if not (TQRDBText(Sender).DataSet=nil) then
              sgProp.Cells [1, nRowProp] := TQRDBText(Sender).DataSet.Name;
           sgProp.Objects [0, nRowProp] := TObject (PropList[nProp]);   
           Inc (nRowProp);
        end else
        begin
           if PropList[nProp].PropType^.Kind <> tkMethod then
           begin
   // name
              sgProp.Cells [0, nRowProp] := PropList[nProp].Name;
   // value
              sgProp.Cells [1, nRowProp] := GetPropValAsString (
                   sender, PropList [nProp]);
   // data
              sgProp.Objects [0, nRowProp] := TObject (PropList[nProp]);
              sgProp.Objects [1, nRowProp] := nil;
   // move to the next line
              Inc (nRowProp);
   // if the property is a class
              if (PropList[nProp].PropType^.Kind = tkClass) then
              begin
                 SubObj := TPersistent (GetOrdProp (
                     sender, PropList[nProp]));
                 if (SubObj <> nil) and not (SubObj is TComponent) then
                 begin
                    NumberOfSubProps := GetTypeData(SubObj.ClassInfo).PropCount;
                    if NumberOfSubProps > 0 then
                    begin
   // add plus sign
                       sgProp.Cells [0, nRowProp - 1] := '+' +
                       sgProp.Cells [0, nRowProp - 1];
   // add space for subproperties...
                       sgProp.RowCount := sgProp.RowCount + NumberOfSubProps;
   // get the list of subproperties and sort it
                       GetPropInfos (subObj.ClassInfo, @SubPropList);
                       SortPropList(@SubPropList, NumberOfSubProps);
   // show the name of each subproperty
                       for nSubProp := 0 to NumberOfSubProps - 1 do
                       begin
   // if it is a real property
                          if SubPropList[nSubProp].PropType^.Kind <> tkMethod then
                          begin
   // name (indented)
                             sgProp.Cells [0, nRowProp] :=
                                 '    ' + SubPropList[nSubProp].Name;
   // value
                             sgProp.Cells [1, nRowProp] := GetPropValAsString (
                                SubObj, SubPropList [nSubProp]);
   // data
                             sgProp.Objects [0, nRowProp] :=
                                TObject (SubPropList[nSubProp]);
                             sgProp.Objects [1, nRowProp] := SubObj;
                             Inc (nRowProp);
                          end; // if
                       end; // for
                    end;
                 end;
              end; // adding subproperties
           end;
        end;
     end;
  end else
     onquickrepmousedown(Sender,Button,Shift, X, Y);

end;
procedure TFormWRC.ONobjDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var s,s1:string;
    i:integer;
begin
   s:=TTreeview(Source).Selected.Text;
   i:=pos(':',s);
   s1:=trim(copy(s,1,i-1));
   accept:=(s1='FieldName') or (s1='DisplayName');
end;

procedure TFormWRC.OnobjDragDrop(Sender, Source: TObject; X, Y: Integer);
var i,j:integer;
    s,s1,s2:string;
    obj:Tobject;
    abutton:TMouseButton;
    aShift:TShiftstate;
    dset:string;
    ADO:TADOQuery;
begin
   s:=TTreeview(Source).Selected.Text;
   i:=pos(':',s);
   s1:=trim(copy(s,1,i-1));
   s2:=trimleft(trimright(copy(s,i+1,length(s)-i)));
//   TTreeview(Source).Selected.Parent
   if (s1='DisplayName') then  //label or qrlabel
   begin
      if (PageControl2.ActivePageIndex=0) then
      begin
         s1:='QRLabel';
         with TWincontrol(Quickrep1) do
         begin
            j:=0;
            i:=0;
            while (i<componentcount) do
            begin
               j:=j+1;
               s:=uppercase(s1+inttostr(j));
               for i:=0 to ComponentCount-1 do
               begin
                  if (uppercase(TControl(Components[i]).Name)=s) then
                     break;
               end;
            end;
         end;
         obj:=TQRLabel.Create(TComponent(Quickrep1));
         With Tbutton(obj) do
         begin
            name:=s;
            parent:=TWinControl(Sender);
            Left:=x;
            Top:=y;
      //            Height:=24;
      //            Width:=20;
            OnMouseDown:=ObjectMouseDown;
         end;
         TQRLabel(obj).Caption:=s2;
      end else
      begin
         s1:='Label';
         with TWincontrol(PanelInput) do
         begin
            j:=0;
            i:=0;
            while (i<componentcount) do
            begin
               j:=j+1;
               s:=uppercase(s1+inttostr(j));
               for i:=0 to ComponentCount-1 do
               begin
                  if (uppercase(TControl(Components[i]).Name)=s) then
                     break;
               end;
            end;
         end;
         obj:=TLabel.Create(TComponent(PanelInput));
         TLabel(obj).Caption:=s2;
      end;
   end else
   begin
      dset:='ADOQuery'+TTreeview(Source).Selected.Parent.Parent.Text;
      ADO:=TADOQuery(QuickRep1.FindComponent(dset));
      if (PageControl2.ActivePageIndex=0) then
      begin
         case ADO.FieldByName(s2).DataType of
            ftMemo:s1:='QRDBrichtext';
            ftGraphic:s1:='QRDBImage';
         else
            s1:='QRDBText';
         end;
         with TWincontrol(Quickrep1) do
         begin
            i:=0;
            j:=1;
            while (i<componentcount) do
            begin
               s:=uppercase(s1+inttostr(j));
               for i:=0 to ComponentCount-1 do
               begin
                  if (uppercase(TControl(Components[i]).Name)=s) then
                    break;
               end;
               if (i<componentcount) then
                  j:=j+1;
            end;
            s:=uppercase(s1+inttostr(j));
         end;
         case ADO.FieldByName(s2).DataType of
            ftMemo:obj:=TQRDBImage.Create(TComponent(Quickrep1));
            ftGraphic:obj:=TQRDBrichtext.Create(TComponent(Quickrep1));
         else
            obj:=TQRDBText.Create(TComponent(Quickrep1));
         end;
         TQRDBText(obj).DataSet:=ADO;
         TQRDBText(obj).DataField:=s2;
      end else
      begin
         case ADO.FieldByName(s2).DataType of
            ftDateTime:s1:='DateTimePicker';
         else
            s1:='Edit';
         end;
         with TWincontrol(PanelInput) do
         begin
            i:=0;
            j:=1;
            while (i<componentcount) do
            begin
               s:=uppercase(s1+inttostr(j));
               for i:=0 to ComponentCount-1 do
               begin
                  if (uppercase(TControl(Components[i]).Name)=s) then
                    break;
               end;
               if (i<componentcount) then
                  j:=j+1;
            end;
            s:=uppercase(s1+inttostr(j));
         end;
         case ADO.FieldByName(s2).DataType of
            ftDateTime:obj:=TDateTimePickerN.Create(TComponent(PanelInput));
         else
            obj:=TEditN.Create(TComponent(PanelInput));
         end;
         TEditN(obj).FieldName:=s2;
         TEditN(obj).DataSetname:=dset;
      end;
   end;
   With Tbutton(obj) do
   begin
      name:=s;
      parent:=TWinControl(Sender);
      Left:=x;
      Top:=y;
      OnMouseDown:=ObjectMouseDown;
   end;
   SpeedButton0.Down:=True;
   SpeedButton19.Down:=True;
   idx:=0;
   idx2:=0;
   ComboBox1.Items.AddObject (Format ('%s: %s',
             [TComponent(obj).Name, TComponent(obj).ClassName]), TComponent(obj));
   Abutton:=mbLeft;
   ObjectMouseDown(obj,Abutton,AShift,0,0);
end;

function TFormWRC.ComponentToString(Component: TComponent): string;
var
  BinStream:TMemoryStream;
  StrStream: TStringStream;
  s: string;
begin
  BinStream := TMemoryStream.Create;
  try
    StrStream := TStringStream.Create(s);
    try
      BinStream.WriteComponent(Component);
      BinStream.Seek(0, soFromBeginning);
      ObjectBinaryToText(BinStream, StrStream);
      StrStream.Seek(0, soFromBeginning);
      Result:= StrStream.DataString;
    finally
      StrStream.Free;

    end;
  finally
    BinStream.Free
  end;
end;

function TFormWRC.StringToComponent(Value: string;parent:Tcomponent): TComponent;
var
  StrStream:TStringStream;
  BinStream: TMemoryStream;
begin
  StrStream := TStringStream.Create(Value);
  try
    BinStream := TMemoryStream.Create;
    try
      ObjectTextToBinary(StrStream, BinStream);
      BinStream.Seek(0, soFromBeginning);
      Result := BinStream.ReadComponent(parent);

    finally
      BinStream.Free;
    end;
  finally
    StrStream.Free;
  end;
end;

procedure TFormWRC.Label3Click(Sender: TObject);
var ADOConn:TADOConnection;
begin
   ADOConn:=TADOConnection.Create(self);
   ADOConn.Connected:=false;
   ADOConn.LoginPrompt:=false;
   ADOConn.ConnectionString:=ADOProj.fieldbyname('proj_alias').AsString;
   if EditConnectionString(ADOConn) then
   begin
      if not(ADOProj.State in [dsedit,dsinsert]) then
         ADOProj.Edit;
      ADOProj.fieldbyname('proj_alias').AsString:=ADOConn.ConnectionString;
   end;
   ADOConn.Free;
end;

procedure TFormWRC.PageControl1Change(Sender: TObject);
var ADOconn:TADOconnection;
begin
   case PageControl1.ActivePageIndex of
      0:begin
        end;
      1:begin
           if (ADOProj.State in [dsedit,dsinsert]) then
              ADOProj.post;
           try
              ADOConn:=TADOConnection.Create(self);
              ADOConn.LoginPrompt:=false;
              ADOConn.Connected:=false;
              ADOConn.ConnectionString:=ADOProj.fieldbyname('proj_alias').AsString;
              try
                 ADOConn.Connected:=true;
              except
                 showmessage('Ʈw|~');
                 PageControl1.ActivePageIndex:=0;
              end;
           finally
              ADOConn.Free;
           end;
        end;
      2:begin
           if (ADOproj_dataset.State in [dsedit,dsinsert]) then
              ADOproj_dataset.post;
           try
              ADOConn:=TADOConnection.Create(self);
              ADOConn.LoginPrompt:=false;
              ADOConn.Connected:=false;
              ADOConn.ConnectionString:=ADOProj.fieldbyname('proj_alias').AsString;
              try
                 ADOConn.Connected:=true;
              except
                 showmessage('Ʈw|~');
                 PageControl1.ActivePageIndex:=0;
              end;
           finally
              ADOConn.Free;
           end;
           if PageControl1.ActivePageIndex=0 then
              Exit;
           if ((TreeView1.Items.Count=0) and (Quickrep1.ComponentCount=0)) then
              SpeedButtonLoadClick(nil);
        end;
   end;
end;

procedure TFormWRC.ADOproj_datasetBeforePost(DataSet: TDataSet);
begin
   ADOproj_dataset.FieldByName('proj_no').AsString:=ADOProj.fieldbyname('proj_no').AsString;
end;

procedure TFormWRC.onquickrepmousedown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var i,j:integer;
    s,s1:string;
    obj:Tobject;
    ab:boolean;
    Abutton:TMouseButton;
    AShift:TShiftstate;
begin
   if (idx>0) or (idx2>0) then
   begin
      if (idx>0) then
      begin
         case idx of
            1:S1:='QRsubdetail';
            2:s1:='QRStringsBand';
            3:s1:='QRBand';
            4:s1:='QRGroup';
            5:s1:='QRLabel';
            6:s1:='QRDBText';
            7:s1:='QRExpr';
            8:s1:='QRSysData';
            9:s1:='QRMemo';
            10:s1:='QRRichText';
            11:s1:='QRDBrichtext';
            12:s1:='QRSHAPE';
            13:s1:='QRIMAGE';
            14:s1:='QRDBImage';
         end;
         with TWincontrol(Quickrep1) do
         begin
            i:=0;
            j:=1;
            while (i<componentcount) do
            begin
               s:=uppercase(s1+inttostr(j));
               for i:=0 to ComponentCount-1 do
               begin
                  if (uppercase(TControl(Components[i]).Name)=s) then
                    break;
               end;
               if (i<componentcount) then
                  j:=j+1;
            end;
            s:=uppercase(s1+inttostr(j));
         end;
         case idx of
            1:obj:=TQRsubdetail.Create(TComponent(Quickrep1));
            2:obj:=TQRStringsBand.Create(TComponent(Quickrep1));
            3:obj:=TQRBand.Create(TComponent(Quickrep1));
            4:obj:=TQRGroup.Create(TComponent(Quickrep1));
            5:obj:=TQRLabel.Create(TComponent(Quickrep1));
            6:obj:=TQRDBText.Create(TComponent(Quickrep1));
            7:obj:=TQRExpr.Create(TComponent(Quickrep1));
            8:obj:=TQRSysData.Create(TComponent(Quickrep1));
            9:obj:=TQRMemo.Create(TComponent(Quickrep1));
            10:obj:=TQRRichText.Create(TComponent(Quickrep1));
            11:obj:=TQRDBrichtext.Create(TComponent(Quickrep1));
            12:obj:=TQRSHAPE.Create(TComponent(Quickrep1));
            13:obj:=TQRIMAGE.Create(TComponent(Quickrep1));
            14:obj:=TQRDBImage.Create(TComponent(Quickrep1));
         end;
      end else
      begin
         case idx2 of
            1:S1:='Label';
            2:s1:='Edit';
            3:s1:='ComBoBox';
            4:s1:='DateTimePicker';
         end;
         with TWincontrol(PanelInput) do
         begin
            i:=0;
            j:=1;
            while (i<componentcount) do
            begin
               s:=uppercase(s1+inttostr(j));
               for i:=0 to ComponentCount-1 do
               begin
                  if (uppercase(TControl(Components[i]).Name)=s) then
                    break;
               end;
               if (i<componentcount) then
                  j:=j+1;
            end;
            s:=uppercase(s1+inttostr(j));
         end;
         case idx2 of
            1:obj:=TLabel.Create(TComponent(PanelInput));
            2:begin
                 obj:=TEditN.Create(TComponent(PanelInput));
                 TEditN(obj).Text:='';
              end;
            3:begin
                 obj:=TComBoBoxN.Create(TComponent(PanelInput));
                 TComboboxN(obj).Text:='';
              end;   
            4:obj:=TDateTimePickerN.Create(TComponent(PanelInput));
         end;

      end;
      With Tbutton(obj) do
      begin
         name:=s;
         if idx in [1,2,3,4] then
         begin
            parent:=Quickrep1;
            Height:=24;
            OnDragOver:=onobjDragover;
            OnDragDrop:=OnobjDragDrop;
         end else
         begin
            parent:=TWinControl(Sender);
            Left:=x;
            Top:=y;
//            Height:=24;
//            Width:=20;
         end;
         OnMouseDown:=ObjectMouseDown;
      end;
      ComboBox1.Items.AddObject (Format ('%s: %s',
              [TComponent(obj).Name, TComponent(obj).ClassName]), TComponent(obj));
      SpeedButton0.Down:=True;
      idx:=0;
      idx2:=0;
      Abutton:=mbLeft;
      ObjectMouseDown(obj,Abutton,AShift,0,0);
   end else
   begin
      StretchHandle1.Detach;
      StretchHandle1.Locked := False;
   end;
end;

procedure TFormWRC.AddToCombo (const S: String);
begin
  Combo.Items.Add (S);
end;

procedure TFormWRC.FormCreate(Sender: TObject);
begin
   RegisterClasses([TQRsubdetail,TQRStringsBand,TQRBand,TQRGroup,TQRLabel,
         TQRDBText,TQRExpr,TQRSysData,TQRMemo,TQRRichText,
         TQRDBrichtext,TQRSHAPE,TQRIMAGE,TQRDBImage,TADOQuery,TADOConnection,
         TLabel,TEditN,TComBoboxN,TDateTimePicker]);
   TButton(Quickrep1).OnMouseDown:=onquickrepmousedown;
   TButton(Quickrep1).OnDragOver:=onobjDragover;
   TButton(Quickrep1).OnDragDrop:=OnobjDragDrop;
   PageControl1.ActivePageIndex:=0;
   CurrComp:=Self;
end;

procedure TFormWRC.SpeedButtonSaveClick(Sender: TObject);
begin
   if not (ADOProj.State in [dsedit,dsinsert]) then
      ADOProj.Edit;
   ADOProj.FieldByName('proj_report').AsString:=ComponentToString(Quickrep1);
   ADOProj.FieldByName('proj_input').AsString:=ComponentToString(PanelInput);
   ADOProj.Post;
end;

procedure TFormWRC.SpeedButtonLoadClick(Sender: TObject);
var ADOQ:TADOQuery;
    ADOConn:TADOConnection;
    MyTreeNode1,MyTreeNode2:TTreeNode;
    i,j:integer;
    fi:boolean;
begin
   SpeedButton0.Down:=True;
   idx:=0;
   with Quickrep1 do
   begin
      while (ComponentCount>0) do
      begin
         Components[0].Free;
      end;
   end;
   with PanelInput do
   begin
      while (ComponentCount>0) do
      begin
         Components[0].Free;
      end;
   end;
   Combobox1.Clear;
   if not (ADOProj.FieldByName('proj_report').AsString='') then
   begin
      StringToComponent(ADOProj.FieldByName('proj_report').AsString,Quickrep1);
      with Quickrep1 do
      begin
         i:=0;
         while (i<ComponentCount) do
         begin
            if (Components[i] is TADOQuery) or (Components[i] is TADOConnection) then
            begin
               if not (Components[i] is TADOConnection) then
               begin
                  ADOproj_dataset.First;
                  fi:=false;
                  while not (ADOproj_dataset.Eof) and not fi do
                  begin
                     fi:='ADOQuery'+ADOproj_dataset.fieldbyname('dataset_name').AsString=
                         TADOQuery(Components[i]).Name;
                     if not fi then
                        ADOproj_dataset.Next;
                  end;
                  if fi then
                  begin
                     TADOQuery(Components[i]).Active:=false;
                     TADOQuery(Components[i]).SQL.Text:=ADOproj_dataset.fieldbyname('dataset_sql').AsString;
                     TADOQuery(Components[i]).Active:=True;
                  end else
                     Components[i].Free;
               end;
            end else
            begin
               if ((Components[i] is TQRBand) or (Components[i] is TQRSubdetail) or
                   (Components[i] is TQRGroup) or (Components[i] is TQRSTringsBand)) then
               begin
                  TButton(Components[i]).OnDragOver:=onobjDragover;
                  TButton(Components[i]).OnDragDrop:=OnobjDragDrop;
               end;
               TButton(Components[i]).OnMouseDown:=ObjectMouseDown;
               ComboBox1.Items.AddObject (Format ('%s: %s',
                  [Components[i].Name, Components[i].ClassName]), Components[i]);
//               ComboBox1.Items.Add(Components[i].Name);
            end;
            i:=i+1;
         end;
      end;
   end;
   if not(ADOProj.FieldByName('proj_input').AsString='') then
   begin
      StringToComponent(ADOProj.FieldByName('proj_input').AsString,PanelInput);
      with PanelInput do
      begin
         i:=0;
         while (i<ComponentCount) do
         begin
            TButton(Components[i]).OnMouseDown:=ObjectMouseDown;
            ComboBox1.Items.AddObject (Format ('%s: %s',
                  [Components[i].Name, Components[i].ClassName]), Components[i]);
            i:=i+1;
         end;
      end;
   end;
//   if ((TreeView1.Items.Count=0)and (Quickrep1.ComponentCount=0)) or (MessageDlg('wgƦsb,O_s',mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
//           begin
   ADOConn:=TADOConnection(Quickrep1.FindComponent('ADOConnection1'));
   if (ADOConn=nil) then
   begin
      ADOConn:=TADOConnection.Create(Quickrep1);
      ADOconn.Name:='ADOConnection1';
   end;
   ADOConn.Connected:=false;
   ADOConn.LoginPrompt:=false;
   ADOConn.ConnectionString:=ADOProj.fieldbyname('proj_alias').AsString;
//              ADOConn.Connected:=True;
   TreeView1.DragMode:=dmManual;
   TreeView1.Items.Clear;
   ADOproj_dataset.First;
   datasetname:='';
   j:=0;
   while not ADOproj_dataset.Eof do
   begin
      j:=j+1;
      ADOQ:=TADOQuery(Quickrep1.FindComponent('ADOQuery'+ADOproj_dataset.fieldbyname('dataset_name').AsString));
      if (ADOQ=nil) then
      begin
         ADOQ:=TADOQuery.Create(Quickrep1);
         ADOQ.Name:='ADOQuery'+ADOproj_dataset.fieldbyname('dataset_name').AsString;
      end;
      ADOQ.Connection:=ADOConn;

      if ADOproj_dataset.fieldbyname('dataset_class').AsInteger=1 then
         Quickrep1.DataSet:=ADOQ;
      ADOQ.Active:=false;
      ADOQ.SQL.Text:=ADOproj_dataset.fieldbyname('dataset_sql').AsString;
      ADOQ.Active:=True;
      MyTreeNode1 := TreeView1.Items.Add(nil,ADOproj_dataset.fieldbyname('dataset_name').AsString);
      for i:=0 to ADOQ.FieldCount-1 do
      begin
         MyTreeNode2:=TreeView1.Items.AddChild(MyTreeNode1,ADOQ.Fields[i].FieldName);
         TreeView1.Items.AddChild(MyTreeNode2,'FieldName:'+ADOQ.Fields[i].FieldName);
         TreeView1.Items.AddChild(MyTreeNode2,'DisplayName:'+ADOQ.Fields[i].displayname);
         TreeView1.Items.AddChild(MyTreeNode2,'Size:'+inttostr(ADOQ.Fields[i].Size));
      end;
      if j=1 then
         datasetname:=datasetname+'ADOQuery'+ADOproj_dataset.fieldbyname('dataset_name').AsString
      else
         datasetname:=datasetname+chr(13)+'ADOQuery'+ADOproj_dataset.fieldbyname('dataset_name').AsString;
      ADOQ.Active:=true;
      ADOproj_dataset.Next;
   end;
end;

procedure TFormWRC.SpeedButton1Click(Sender: TObject);
begin
   if TSpeedButton(sender).Down then
      idx:=TSpeedButton(sender).Tag
   else
   begin
      SpeedButton0.Down:=True;
      idx:=0;
   end;
   SpeedButton19.Down:=True;
   idx2:=0;
   StretchHandle1.Detach;
   StretchHandle1.Locked := False;
end;

procedure TFormWRC.SpeedButtonClearClick(Sender: TObject);
var i:integer;
begin
   with Quickrep1 do
   begin
      i:=0;
      while (ComponentCount>i) do
      begin
         if not ((Components[i] is TADOQuery) or (Components[i] is TADOConnection)) then
            Components[i].Free
         else
            i:=i+1;   
      end;
   end;
   with PanelInput do
   begin
      i:=0;
      while (ComponentCount>i) do
      begin
         Components[i].Free;
      end;
   end;
end;

procedure TFormWRC.StretchHandle1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i,j:integer;
    obj:TwinControl;
begin
   if key=vk_delete then
   begin
      for i:=0 to StretchHandle1.ChildCount-1 do
      begin
         obj:=TwinControl(StretchHandle1.Children[i]);
         for j:=0 to obj.ControlCount-1 do
            obj.Controls[j].Free;
         Combobox1.Items.Delete(Combobox1.Items.IndexOf(Combobox1.Text));
         Combobox1.Text:='';
         StretchHandle1.Children[i].Free;
      end;
      StretchHandle1.Detach;
      sgProp.RowCount:=1;
      sgProp.ColCount:=1;
      sgProp.Cells[0,0]:='';
   end;
end;

procedure TFormWRC.ComboBox1CloseUp(Sender: TObject);
var obj:Tobject;
    button:TMouseButton;
    Shift:TShiftstate;
begin
   button:=mbLeft;
   if uppercase(copy(ComboBox1.Items[ComboBox1.ItemIndex],1,2))='QR' then
   begin
      PageControl2.ActivePageIndex:=0;
      obj := Tobject(ComboBox1.Items.Objects [ComboBox1.ItemIndex] as TComponent);
//      obj:=Tobject(Quickrep1.FindComponent(ComboBox1.Items[ComboBox1.ItemIndex]));
   end else
   begin
      PageControl2.ActivePageIndex:=1;
      obj := Tobject(ComboBox1.Items.Objects [ComboBox1.ItemIndex] as TComponent);
//      obj:=Tobject(Panelinput.FindComponent(ComboBox1.Items[ComboBox1.ItemIndex]));
   end;
   if not (obj=nil) then
   begin
      ObjectMouseDown(obj,button,Shift,0,0);
   end;
end;

procedure TFormWRC.TreeView1Click(Sender: TObject);
begin
   if TreeView1.Selected.Level=2 then
   begin
      TreeView1.DragMode:=dmAutomatic;
      StretchHandle1.Detach;
   end else
      TreeView1.DragMode:=dmManual;
end;

procedure TFormWRC.sgPropSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
var
  sg: TStringGrid;
  ppInfo: PPropInfo;
  I: Integer;
  Ch: Char;
  s:string;
  obj:Tobject;
  procedure PlaceControl (Ctrl: TWinControl);
  begin
     Ctrl.BringToFront;
     Ctrl.Show;
     Ctrl.BoundsRect := sg.CellRect (ACol, ARow+2);
     Ctrl.Left:=Ctrl.Left+2;
     Ctrl.Width:=Ctrl.Width+2;
     Ctrl.SetFocus;
  end;
begin
   sg := Sender as TStringGrid;
   ppInfo := PPropInfo (sg.Objects [0, ARow] );
   if (ppInfo = nil) or not (Acol=1) then
      Exit;
   currrow:=ARow;
   CurrProp := ppInfo;
   if sg.Objects [1, ARow] <> nil then
      CurrComp := TComponent (sg.Objects [1, ARow]);
   if ppInfo.Name='DataSet' then
   begin
      Combo := ComboEnum;
      Combo.Clear;
      combo.Items.Add(datasetname);
      Combo.ItemIndex := Combo.Items.IndexOf(sg.Cells[1,ARow]);
      PlaceControl (Combo);
   end else
   begin
      case ppInfo.PropType^.Kind of
         tkInteger:begin
            if ppInfo.PropType^.Name = 'TCursor' then
            begin
               Combo:=ComboEnum;
               Combo.Clear;
               GetCursorValues (AddToCombo);
               Combo.Text := sg.Cells[1,ARow];
               PlaceControl (Combo);
            end else
            begin
               if ppInfo.PropType^.Name = 'TColor' then
               begin
                  Combo := ComboEnum;
                  Combo.Clear;
                  GetColorValues (AddToCombo);
   //               Combo.Tag := GetOrdProp (TComponent (sg.Objects [1, ARow]), ppInfo);
                  Combo.Text:= sg.Cells[1,ARow];
                  PlaceControl (Combo)
               end else
               begin
                  EditNum.Text := sg.Cells[1,ARow];
                  PlaceControl (EditNum);
   //               EditModified := False;
               end;
            end;
         end;
         tkChar:begin
            EditNum.Text := sg.Cells[1,ARow];
            PlaceControl (EditNum);
   //         EditModified := False;
         end;
         tkEnumeration:
         begin
            Combo := ComboEnum;
            Combo.Clear;
            ListEnum (ppInfo.PropType^, Combo.Items, False);
            Combo.ItemIndex := Combo.Items.IndexOf(sg.Cells[1,ARow]);
            PlaceControl (Combo);
         end;
         tkString, tkLString:begin
            if ppInfo.Name= 'DataSetname' then
            begin
               Combo := ComboEnum;
               Combo.Clear;
               combo.Items.Add(datasetname);
               Combo.ItemIndex := Combo.Items.IndexOf(sg.Cells[1,ARow]);
               PlaceControl (Combo);
            end else
            begin
               if (ppInfo.Name= 'FieldName') or (ppInfo.Name= 'DataField') then
               begin
                  Combo := ComboEnum;
                  Combo.Clear;
                  if (StretchHandle1.Children[0] is TEditN) or (StretchHandle1.Children[0] is TComboboxN) or
                     (StretchHandle1.Children[0] is TDatetimepickerN) then
                  begin
                     s:=TEditN(StretchHandle1.Children[0]).DataSetname;
                     if not (s='') then
                     begin
                        obj:=QuickRep1.FindComponent(s);
                        if (obj=nil) then
                        begin
                           showmessage('dLdataset');
                        end else
                        begin
                           for i:=0 to TADOQuery(obj).FieldCount-1 do
                              Combo.Items.Add(TADOQuery(obj).Fields[i].FieldName);
                        end;
                     end;
                  end else
                  begin
                     if not (TQRDBText(StretchHandle1.Children[0]).Dataset=nil) then
                     begin
                        obj:=TQRDBText(StretchHandle1.Children[0]).Dataset;
                        for i:=0 to TADOQuery(obj).FieldCount-1 do
                              Combo.Items.Add(TADOQuery(obj).Fields[i].FieldName);
                     end;
                  end;
                  Combo.ItemIndex := Combo.Items.IndexOf(sg.Cells[1,ARow]);
                  PlaceControl (Combo);
               end else
               begin
                  EditNum.Text := sg.Cells[1,ARow];
                  PlaceControl (EditNum);
               end;
            end;
   //         EditModified := False;
         end;
         tkSet:
         begin
   {
            ListSet.Clear;
            ListEnum (
               GetTypeData (ppInfo.PropType^).CompType^,
               ListSet.Items, False);
            // select the "on" items
            for I := 0 to ListSet.Items.Count - 1 do
               ListSet.Selected [I] :=IsBitOn(GetOrdProp (CurrComp, ppINfo), I);
            PlaceControl (ListSet);
            ListSet.Height := ListSet.Height * 8;
   }
         end;
         // tkClass: //// see double click...
      end;
   end;
end;

procedure TFormWRC.ComboEnumExit(Sender: TObject);
begin
   sgprop.Cells [1, CurrRow] :=TEdit(Sender).Text;
  (Sender as TWinControl).SendToBack;
end;

procedure TFormWRC.SpeedButton19Click(Sender: TObject);
begin
   if TSpeedButton(sender).Down then
   begin
      idx2:=TSpeedButton(sender).Tag;
   end else
   begin
      SpeedButton19.Down:=True;
      idx2:=0;
   end;
   SpeedButton0.Down:=True;
   idx:=0;
   StretchHandle1.Detach;
   StretchHandle1.Locked := False;
end;

procedure TFormWRC.ComboEnumChange(Sender: TObject);
var
   ppInfo: PPropInfo;
   I: Integer;
   Color: LongInt;
   ch:char;
   obj:Tobject;
   ADOQ:TADOQuery;
begin
   obj:=StretchHandle1.Children[0];
   StretchHandle1.Detach;
   ppInfo := PPropInfo (sgprop.Objects [0, currrow]);
   if (ppInfo = nil) then
      exit;
   if ppInfo.Name='DataSet' then
   begin
      ADOQ:=TADOQuery(Quickrep1.FindComponent(TEdit(Sender).Text));
      if ADOQ=nil then
         showmessage('Dataset Error')
      else
         TQRDBText(obj).DataSet:=ADOQ;
   end else
   begin
      case ppInfo.PropType^.Kind of
         tkInteger:begin
            if ppInfo.PropType^.Name = 'TCursor' then
            begin
               SetOrdProp (CurrComp, CurrProp,
                  StringToCursor (TEdit(Sender).Text));
            end else
            begin
               if ppInfo.PropType^.Name = 'TColor' then
               begin
                  if IdentToColor (TEdit(Sender).Text, Color) then
                  else
                  begin
                     TEdit(Sender).Text := sgprop.Cells[1,currRow];
                     IdentToColor (TEdit(Sender).Text, Color);
                  end;
                  SetOrdProp(CurrComp, CurrProp, Color);
               end else
               begin
                  try
                     SetOrdProp (CurrComp, CurrProp, StrToInt(TEdit(Sender).Text));
                  except
                     showmessage('пJƦr');
                  end;
               end;
            end;
         end;
         tkChar:begin
            try
               if Length (TEdit(Sender).Text) = 1 then
                  Ch := TEdit(Sender).Text [1]
               else
                 if TEdit(Sender).Text [1] = '#' then
                    Ch := Char (StrToInt (Copy (
                       TEdit(Sender).Text, 2, Length (TEdit(Sender).Text) - 1)))
                 else
                    raise EConvertError.Create ('Error');
               SetOrdProp (CurrComp, CurrProp, Word (Ch));
            except
              on EConvertError do
                 begin
                    ShowMessage ('Not a valid character');
                    TEdit(Sender).SetFocus;
                 end;
            end;
   //         EditNum.Text := sg.Cells[1,ARow];
   //         PlaceControl (EditNum);
   //         EditModified := False;
         end;
         tkEnumeration:
         begin
            SetOrdProp (CurrComp, CurrProp,
              GetEnumValue (CurrProp.PropType^, TEdit(Sender).Text));
         end;
         tkString, tkLString:begin
            SetStrProp (CurrComp, CurrProp, TEdit(Sender).Text);
         end;
         tkSet:
         begin
   {
            ListSet.Clear;
            ListEnum (
               GetTypeData (ppInfo.PropType^).CompType^,
               ListSet.Items, False);
            // select the "on" items
            for I := 0 to ListSet.Items.Count - 1 do
               ListSet.Selected [I] :=IsBitOn(GetOrdProp (CurrComp, ppINfo), I);
            PlaceControl (ListSet);
            ListSet.Height := ListSet.Height * 8;
   }
         end;
         // tkClass: //// see double click...
       end;
    end;
    StretchHandle1.Attach(Tcontrol(obj));
    TEdit(Sender).BringToFront;
    TEdit(Sender).SetFocus;
end;

procedure TFormWRC.Button1Click(Sender: TObject);
var s:string;
begin
   numtot:=0;
   s:=Extractfiledir(Application.ExeName);
   Makeexe(s+'\'+ADOProj.fieldbyname('proj_no').AsString+'.exe',s+'\wrc.dll');
end;

end.
